/*->h.dbchoices */


#define CHPANEICON 5

typedef os_error * (*choicesavefn)(buffer * bf);
typedef os_error * (*choiceclosefn)(int code);
typedef os_error * (*choicepanefn)(int select);
typedef os_error * (*choiceopenfn)(void);

typedef os_error * (*choicechangefn)(void * olddata,
                                     void * newdata,viewstr * view);

typedef os_error * (*choicedscriptfn)(buffer * bf,void * data,filestr * file);


typedef struct subchoicestr
{
 struct subchoicestr * next;

 dboxstr             * dbox;

 char                * sprite;
 char                * name;

 choicesavefn          save;    /* call when choices file being saved    */
 choiceclosefn         close;   /* call when choices window being closed */
 choicepanefn          pane;    /* call when choices pane open/close     */
 choiceopenfn          open;    /* call when choices window opened       */
 choicechangefn        change;  /* call when choices changed             */
 choicedscriptfn       dscript; /* call to save prefs in DDL             */

} subchoicestr;


extern os_error * choicesadd(subchoicestr * subchoice);

extern os_error * choicechangevalue(int * value);

extern dbstackstr dbchoicestack;
extern dboxstr    choicebox[3];

extern subchoicestr * firstpref;

extern os_error * prefchangevalue(int * value);
extern os_error * prefadd(subchoicestr * subchoice);

