/*->h.group */

typedef struct groupstr
{
 int            key;
 int            type;
 chainstr       chain;
 flagstr        flags;

 boxstr         box;
 transformstr   transform;

 curvestr       fcurve;    /* frame curve    */
 curvestr       icurve;    /* internal curve */
 curvestr       ocurve;    /* external curve */
 textflowstr    textflow;

 int            master;

} groupstr;



extern os_error * groupupdate(int group,int lock,int spread,filestr * file);

extern void groupselection(int fp);
extern void ungroupselection(int fp);
extern int  canungroup(int fp);
extern int  cangroup(int fp);
extern int  cangoforward(int fp);
extern int  cangobackward(int fp);
extern void objectforward(int fp);
extern void objectbackward(int fp);
extern void objectforwardn(int fp);
extern void objectbackwardn(int fp);

extern os_error * groupinit(void);


