/*->c.conf */

#include <stdafx.h>

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>


#include "os.h"
#include "wimp.h"
#include "wimpt.h"

#include "wos.h"

#include "poll.h"
#include "temp.h"
#include "trans.h"
#include "etc.h"
#include "deb.h"
#include "bits.h"

#include "conf.h"


static int conf_ok;
static int doconfirm=1;
static int conmode;

             /* CONYN Yes/No CONDN Discard/Cancel CONDCS Discard/Cancel/Save */


#define TXIC  12
#define YESIC 11


static os_error * conficon(wimp_w handle,uservalue userhandle,wimp_mousestr * m)
{

 switch(m->i)
 {
  case 0:
  case YESIC:
         conf_ok=(m->i==YESIC);
         break;

  case 4:
  case 5:
         conf_ok=-1;  /* Cancel */
         break;

  case 6:
         conf_ok=1; /* Save  */
         break;

  case 3:
         if(conmode==CONDC) conf_ok=1;  /* Discard same as  YES */
                                        /* Are you sure you want to Quit? */
         else
         if(conmode==CONDCS) conf_ok=0; /* Discard==No  */
         break;
 }

 return(NULL);

 handle=handle;
 userhandle=userhandle;
}



static os_error * confkey(wimp_w handle,uservalue userhandle,int icon,int * key)
{
 int ch;

 ch=toupper(*key);

 if(*key==27)
 {
  conf_ok=-1;
 }
 else
 if(conmode==CONYN)
 {
  if(ch=='Y' || ch==13) conf_ok=1;
  else
  if(ch=='N') conf_ok=0;
 }
 else
 if(conmode==CONDC)
 {
  if(ch=='C') conf_ok=-1;
  else
  if(ch=='D') conf_ok=1;
 }
 else
 if(conmode==CONDCS)
 {
  if(ch=='S' || ch==13) conf_ok=1;
  else
  if(ch=='D') conf_ok=0;
  else
  if(ch=='C') conf_ok=-1;
 }

 if(conf_ok!=-2) *key=-1;

 return(NULL);

 USE(handle);
 USE(userhandle);
 USE(icon);
}



/*
static void czero(int userhandle)
{
 USE(userhandle);
}

*/



os_error * messageboxquery(wimp_w parent,int mode,int * result,char * format, ...)
{
 os_error    * err;
 va_list       args;
 char          string[256];
 char          temp[256];
 int           res;
 int           flags;
 int           len;

 flags=mode & 0xFF0000;
 if(flags==MQWARN) flags=MB_ICONWARNING;
 else
 if(flags==MQINFO) flags=MB_ICONINFORMATION;
 else
 if(flags==MQQUES) flags=MB_ICONQUESTION;
 else
 if(flags==MQSTOP) flags=MB_ICONSTOP;
 else              flags=0;

 mode=mode & 0xFFFF;

 if(mode==MQOK)  mode=MB_OK;
 else
 if(mode==MQOKC) mode=MB_OKCANCEL;
 else
 if(mode==MQYN)  mode=MB_YESNO;
 else
 if(mode==MQYNC) mode=MB_YESNOCANCEL;
 else            mode=MB_OK;

 mode=mode | flags;
 
 xzstrncpy(temp,format,sizeof(temp)/sizeof(TCHAR));
 err=trans(temp,sizeof(temp)/sizeof(TCHAR));

 va_start(args,format);
 VSNPRINTF(string,sizeof(string)/sizeof(TCHAR),temp,args,len);
 va_end(args);


 res=MessageBox((HWND)parent,string,wimpt_programtextname(),mode);

 if(res==IDCANCEL) *result=MQRC;
 else
 if(res==IDOK)     *result=MQROK;
 else
 if(res==IDYES)    *result=MQRY;
 else
 if(res==IDNO)     *result=MQRN;
 else              *result=0;

 return(NULL);
}


static os_error * confclose(wimp_w handle,uservalue userhandle)
{
 conf_ok=-1;
 return(NULL);
 USE(handle);
 USE(userhandle);
}





/* returns 1==OK 0==NO -1==FORGET IT */


os_error * confirmparent(wimp_w parent,int mode,int * result,TCHAR * format, ...)
{
 va_list       args;
 TCHAR         string[256];
 TCHAR         temp[256];
 wimp_w        handle=NULL;
 os_error  *   err;
// windowstr     window;
 wimp_caretstr cblock;
 int           force;
 static int    active;
 int           len;


 xzstrncpy(temp,format,sizeof(temp)/sizeof(TCHAR));
 err=trans(temp,sizeof(temp)/sizeof(TCHAR));

 va_start(args,format);
 VSNPRINTF(string,sizeof(string)/sizeof(TCHAR),temp,args,len);
 va_end(args);

 if(active)
 {
  *result=-1;
 }
 else
 {
  active=1;

  force=mode & CONFORCE;
  mode&=~CONFORCE;

  cprintf("force %d doconfirm %d",force,doconfirm);

  if(!doconfirm && !force)
  {
   if(mode==CONDCS) *result=0;
   else             *result=1;
  }
  else
  {
   *result=-1;
   err=trans(string,sizeof(string)/sizeof(TCHAR));
   if(!err) 
   {
    err=createwindowtitleparent(TCONF,wimpt_programtextname(),&handle,parent);
   }

   if(!err)
   {
    conmode=mode;

    writeicon(handle,TXIC,string);

    if(mode==CONYN)
    {
     wimp_delete_icon(handle,3);
     wimp_delete_icon(handle,4);
     wimp_delete_icon(handle,5);
     wimp_delete_icon(handle,6);
    }
    else
    if(mode==CONDC)
    {
     wimp_delete_icon(handle,0);
     wimp_delete_icon(handle,YESIC);
     wimp_delete_icon(handle,5);
     wimp_delete_icon(handle,6);
    }
    else
    if(mode==CONDCS)
    {
     wimp_delete_icon(handle,0);
     wimp_delete_icon(handle,YESIC);
     wimp_delete_icon(handle,4);
    }

    conf_ok=-2;

    addkeyevent(confkey,handle,0);
    addclickevent(conficon,handle,0);
//    addzeroevent(czero,0);
    addhelpevent(NULL,handle,TCONF);
    addcloseevent(confclose,handle,0);

    err=wimp_get_caret_pos(&cblock);

    if(parent) EnableWindow((HWND)parent,0);

    err=popup(handle,0);
    if(!err)
    { 
     setfocus(handle);

     while(conf_ok==-2)
     {
//      err=getw(handle,&window);
//      cprintf("flags %x err=%x",window.wflags,err);
// this isn't doing much - how can the window just close? cf ALT+F4
/*
      if(!(window.wflags & 0x10000) || err)
      {
       conf_ok=-1;
       break;
      }
 */
      poll();
     }

//     closedowncheck(handle);
    }

    if(parent) EnableWindow((HWND)parent,1);

    err=wimp_set_caret_pos(&cblock);

    remkeyevent(confkey,handle,0);
    remclickevent(conficon,handle,0);
//    remzeroevent(czero,0);
    remhelpevent(NULL,handle,TCONF);
    remcloseevent(confclose,handle,0);

    closedown(&handle);
   }

   *result=conf_ok;
  }
  active=0;
 }

 return(err);
}


void confirmset(int docon)
{
 doconfirm=docon;
}




static templates temptable[]=
{
 TCONF,1,0,"Confirm",

 TLAST,  0,0,""
};


static templink templatelink;



os_error * confwindowinit(void)
{
 return(addtemplates(NULL,NULL,temptable,&templatelink));
}

