/*->c.dbmore */



#include "stdafx.h"

#include <stdlib.h>
#include <stdarg.h>
#include <string.h>
#include <stdio.h>
#include <locale.h>

#include "os.h"
#include "wimp.h"
#include "wimpt.h"
#include "werr.h"
#include "akbd.h"
#include "transform.h"

#include "wos.h"

#include "err.h"
#include "task.h"
#include "xext.h"
#include "poll.h"
#include "key.h"
#include "temp.h"
#include "etc.h"
#include "bf.h"
#include "fsx.h"
#include "timex.h"
#include "bits.h"
#include "conf.h"
#include "dbhi.h"
#include "xmath.h"
#include "deb.h"


#include "str.h"

#include "obj.h"

#include "units.h"
#include "reslink.h"

#include "view.h"
#include "viewo.h"
#include "file.h"
#include "tools.h"
#include "infopal.h"
#include "buttons.h"
#include "rulers.h"
#include "editpath.h"
#include "undo.h"
#include "txchoices.h"
#include "clip.h"
#include "object.h"
#include "select.h"

#include "dbchoices.h"
#include "choices.h"

#include "dbmore.h"



/****************************************************************************/

static int xtoolbox;
static int xinfopal;
static int xtoolboxoff;
static int xinfopaloff;
static int xinstant;


static int  xtxflash;
       int  txflash;

static int  xtxperiod;
       int  txperiod;
       int  txperiods;
       int  txcycle=0x8000;

static int  xtruefonts;
static int  truefonts;

static int  xcrosshairs;

static int  xlongclick;




#define SNAPXRANGE 12
/*(MMSIZE*3) */
#define SNAPYRANGE 12
/*(MMSIZE*3) */


       int  nodropshadow;
       int  snapxrange=SNAPXRANGE;
       int  snapyrange=SNAPYRANGE;

       int  defwindowx0;
       int  defwindowx1;
       int  defwindowy0;
       int  defwindowy1;




static os_error * out(int value,char * string)
{
 strcpy(string,numbertostring(value));
 return(NULL);
}


static os_error * in(int * value,char * string)
{
 os_error * err;
 err=stringtonumber(string,value);
 return(err);
}



static os_error * chviewclose(int code)
{
	viewstr * view;

 if(code==DBOK || code==DBAPPLY)
 {
  toolschangeattachment(xtoolbox);
  infopalattached=xinfopal;
  instantpathedit=xinstant;
  infopaloffscreen=xinfopaloff;
  toolboxoffscreen=xtoolboxoff;
  truefonts=xtruefonts;
  crosshairs=xcrosshairs;
  txflash=xtxflash;
  txperiod=xtxperiod;
  txperiods=scale(txperiod,txcycle,0x10000);
		longclick=xlongclick;

		view=choicesview();
		defwindowx0=view->mainwindow.x0;
		defwindowx1=view->mainwindow.x1;
		defwindowy0=view->mainwindow.y0;
		defwindowy1=view->mainwindow.y1;
 }

 return(NULL);
}


void viewchoices1(int fp)
{
 instantpathedit=stack[fp];
 txflash=stack[fp+1];
 txperiod=stack[fp+2];
 txcycle=stack[fp+3];
 txcycle=CUT(txcycle,0,0x10000);
 txperiods=scale(txperiod,txcycle,0x10000);
 truefonts=stack[fp+4];
}



void viewchoices2(int fp)
{
 toolboxattached =(stack[fp] & 0x1);
 toolboxoffscreen=(stack[fp] & 0x2)>>1;
 toolboxposnx    =stack[fp+1];
 toolboxposny    =stack[fp+2];
 infopalattached =(stack[fp+3] & 0x1);
 infopaloffscreen=(stack[fp+3] & 0x2)>>1;
 infopalposnx    =stack[fp+4];
 infopalposny    =stack[fp+5];
}



void viewchoices3(int fp)
{
 nodropshadow=stack[fp] & 0x1;
 crosshairs=(stack[fp]>>1) & 0x1;

 /* fp+1 is spare */

 snapxrange=stack[fp+2];
 snapyrange=stack[fp+3];


}


void viewchoices4(int fp)
{
 defwindowx0=stack[fp];
	defwindowx1=stack[fp+1];
	defwindowy0=stack[fp+2];
	defwindowy1=stack[fp+3];

}



void viewchoices5(int fp)
{
 longclick=stack[fp];


}



static os_error * chviewsave(buffer * bf)
{
	os_error * err;
	viewstr  * view;

 err=bf_printfeol(bf,"viewchoices1(%d,%d,%d,%d,%d);",instantpathedit,
                                      txflash,txperiod,txcycle,truefonts);

 if(!err) err=bf_printfeol(bf,"viewchoices2(%d,%d,%d,%d,%d,%d);",
                      toolboxattached|(toolboxoffscreen<<1),
                      toolboxposnx,toolboxposny,
                      infopalattached|(infopaloffscreen<<1),
                      infopalposnx,infopalposny);

 if(!err) err=bf_printfeol(bf,"viewchoices3(%d,%d,%d,%d);",
                      (nodropshadow & 0x1)|((crosshairs & 0x1)<<1),0,
                      snapxrange,snapyrange);

	if(!err)
	{
		view=choicesview();

  err=bf_printfeol(bf,"viewchoices4(%d,%d,%d,%d);",
																							view->mainwindow.x0,
																							view->mainwindow.x1,
																							view->mainwindow.y0,
																							view->mainwindow.y1
                      );
	}

	if(!err)	err=bf_printfeol(bf,"viewchoices5(%d,%d,%d,%d);",longclick,0,0,0);

	return(err);
}



static dbiconstr chviewicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

   22, &xtxperiod,  DBWRITE,  0,    0,     -1, -1, -1, -1,   in,  out,
   24, &xlongclick, DBWRITE,  0,    0,     -1, -1, -1, -1,   in,  out,

    7, &xtxflash,   DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,

    3, &xtoolbox,   DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
    4, &xinfopal,   DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,
   10, &xtoolboxoff,DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
   11, &xinfopaloff,DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,

    5, &xinstant,   DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,

    6, &xtruefonts, DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,

    9, &xcrosshairs,DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,


   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};


static os_error * chviewopen(void)
{
 xtoolbox=toolboxattached;
 xinfopal=infopalattached;
 xtoolboxoff=toolboxoffscreen;
 xinfopaloff=infopaloffscreen;
 xinstant=instantpathedit;
 xtruefonts=truefonts;
 xcrosshairs=crosshairs;
 xtxflash=txflash;
 xtxperiod=txperiod;
	xlongclick=longclick;
 return(NULL);
}


static dboxstr chviewbox=
{
 0,
 TCHVIEW,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 chviewicondefs,
 0,
 0,

 0,NULL,
 0,
 0,

};


static subchoicestr chview=
{
 NULL,

 &chviewbox,

 "ch_view",
 "{CHV0}",

 chviewsave,
 chviewclose,
 NULL,
 chviewopen,
 NULL,
 NULL,
};


/*****************************************************************************/

static int  xwarnings;
       int  warnings;

static int  xihelp;
       int  ihelp;

static char xtimeformat[SYSDTLEN];
static char xdateformat[SYSDTLEN];

static int  xsaveundo;
static int  xundosize;
static int  xglobalclip;
static int  xcbmax;
static int  xfiletest;

       int  multiuser=1;


int getmultiuser(void)
{
 return(multiuser);
}


static os_error * outk(int value,char * string)
{
 strcpy(string,numbertostring(value/1024));
 return(NULL);
}


static os_error * ink(int * value,char * string)
{
 os_error * err;
 err=stringtonumber(string,value);
 *value=(*value)*1024;
 return(err);
}




static os_error * outdate(int value,char * string)
{
 strcpy(string,xdateformat);
 return(NULL);
 USE(value);
}


static os_error * indate(int * value,char * string)
{
 xzstrncpy(xdateformat,string,sizeof(xdateformat));
 return(NULL);
 USE(value);
}



static os_error * outtime(int value,char * string)
{
 strcpy(string,xtimeformat);
 return(NULL);
 USE(value);
}


static os_error * intime(int * value,char * string)
{
 xzstrncpy(xtimeformat,string,sizeof(xtimeformat));
 return(NULL);
 USE(value);
}




static os_error * chgeneralclose(int code)
{
 os_error * err;

 err=NULL;

 if(code==DBOK || code==DBAPPLY)
 {
  timexinitsys(xdateformat,xtimeformat);
  confirmset(warnings=xwarnings);
  ihelp=xihelp;
  saveundo=xsaveundo;
  filetest=xfiletest;
           err=undosetsize(xundosize);
  if(!err) err=setclipboardchoices(xglobalclip,xcbmax);
 }

 return(err);
}


static os_error * chgeneralsave(buffer * bf)
{
 char scrap1[128];
 char scrap2[128];
 int  xglobal;
 int  xcbm;

 getclipboardchoices(&xglobal,&xcbm);

 bf_printfeol(bf,"undochoices(%d,%d);",saveundo,undosize);

 bf_printfeol(bf,"generalchoices2(%d,%d,%d,%d);",xglobal,xcbm,filetest,0);

 return(bf_printfeol(bf,"generalchoices(\"%s\",\"%s\",%d,%d);",
                                              unquotec(syststring,scrap1),
                                              unquotec(sysdstring,scrap2),
                                              warnings,ihelp));
}



void generalchoices(int fp)
{
 xzstrncpy(xtimeformat,stringptr(stack[fp]),sizeof(xtimeformat));
 xzstrncpy(xdateformat,stringptr(stack[fp+1]),sizeof(xdateformat));
 timexinitsys(xdateformat,xtimeformat);
 confirmset(warnings=stack[fp+2]);
 ihelp=stack[fp+3];
}


void generalchoices2(int fp)
{
 int xglobal;
 int xcbm;

 xglobal=stack[fp];
 xcbm=stack[fp+1];
 filetest=stack[fp+2];

 zreport(setclipboardchoices(xglobal,xcbm));
}



int readgeneralchoices2(int fp)
{
 int  xglobal;
 int  xcbm;

 getclipboardchoices(&xglobal,&xcbm);

 switch(stack[fp])
 {
  case 0:
         return(xglobal);

  case 1:
         return(xcbm);

  case 2:
         return(filetest);

  case 3:
         return(0);
 }

 return(0);
}





void undochoices(int fp)
{
 saveundo=stack[fp];
 undosetsize(stack[fp+1]);
}



static dbiconstr chgeneralicondefs[]=
{
 /* N   &V           Type     Grp   Flags   R   L   D   U     In    Out */

    3, NULL,  DBWRITENC,0, DBALPHATX,-1, -1, -1, -1, intime,outtime,
   22, NULL,  DBWRITENC,0, DBALPHATX,-1, -1, -1, -1, indate,outdate,

    9, &xwarnings,  DBTOGGLE, 0,    0,      1,  F2, 0, 0,  NULL,    0,
    4, &xsaveundo,  DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
    6, &xundosize,  DBWRITE,  0,    0,     -1, -1, -1, -1,   ink,  outk,
    8, &xihelp,     DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
   12, &xglobalclip,DBTOGGLE, 0,    0,      1,  F1, 0, 0,  NULL,    0,
   14, &xcbmax,     DBWRITE,  0,    0,     -1, -1, -1, -1,   in,  out,
   15, &xfiletest,  DBTOGGLE, 0,    0, FILELDTST,F1, 0, 0,  NULL,    0,
   16, &xfiletest,  DBTOGGLE, 0,    0, FILESVTST,F1, 0, 0,  NULL,    0,

   -1, NULL,         0,       0,    0,      0,  0,  0,  0,  0,      0
};



static os_error * chgeneralopen(void)
{
 os_error      * err;

 err=NULL;

 xzstrncpy(xdateformat,sysdstring,sizeof(xdateformat));
 xzstrncpy(xtimeformat,syststring,sizeof(xtimeformat));
 xwarnings=warnings;
 xsaveundo=saveundo;
 xundosize=undosize;
 xihelp=ihelp;
 xfiletest=filetest;

 getclipboardchoices(&xglobalclip,&xcbmax);

 return(err);
}



static dboxstr chgeneralbox=
{
 0,
 TCHGENERAL,
 DBPANE,
 0,
 NULL,
 NULL,
 NULL,
 NULL,
 chgeneralicondefs,
 0,
 0,

 0,NULL,
 0,
 0,
};


static subchoicestr chgeneral=
{
 NULL,

 &chgeneralbox,

 "ch_general",
 "{CHG0}",

 chgeneralsave,
 chgeneralclose,
 NULL,
 chgeneralopen,
 NULL,
 NULL,
};



/*****************************************************************************/


os_error * dbmoreinit(void)
{
 choicesadd(&chgeneral);
 return(choicesadd(&chview));
}


