/*->h.fit */



typedef struct fitstr
{
 coordstr * pointstore;
 int        npoints;
 int        maxpoints;
 int        spddx;
 int        spddy;
 int      * path;
 int        pathsize;
 int        maxpathsize;
} fitstr;


extern os_error * vecclose(fitstr * fit);
extern os_error * vecend(fitstr * fit);
extern os_error * vecopen(fitstr * fit);
extern os_error * vecclear(fitstr * fit);


extern os_error * fitcurve(fitstr * fit,int vec,int npoints);

extern os_error * fitinit(void);


